'VJEZBA OPTIMALNA FERMENTACIJA PENICILINA
CLS
PRINT " ---------------------------------------------------------"
PRINT " Lab MRA/ Prehrambeno biotehnolo{ki fakultet u Zgb."
PRINT " MATEMATICKO MODELIRANJE I VODJENJA INDUSTRIJSKIH PROCESA"
PRINT " ---------------------------------------------------------"
PRINT " VJEZBA:"
PRINT " OPTIMIRANJE FERMENTACIJE PENICILINA PRITOKOM "
PRINT : PRINT
'parametri
mim = .11
K1 = .006
tetaM = .004
Kp = .0001
Ki = .1
K = .01
Yx = .47
Yp = 1.2
Mx = .029
CT = 6913.58
CP = .025
CS = .0008547
' pocetna i konacna stanja
Vo = 250000!
Vf = 500000!
xp = 1.5
sp = 1
pp = 0
Tf = 150

' izbor pritoka q(m3/h) i
' koncentracije glukoze sf(g/l)
PRINT "ZADAJTE UPRAVLJACKE VELICINE"
PRINT
DIM q(16), sf(16)
ttimef = 0
FOR i = 1 TO 16
11 PRINT "vrijeme(h)="; ttimef
INPUT "q(m3/h)="; q(i)
INPUT "sf(g/l)="; sf(i)
IF q(i) < 0 OR sf(i) < 0 THEN GOTO 11
ttimef = ttimef + 10
PRINT
q(i) = q(i) * 1000
NEXT i

' funkcije modela

DEF fnm (s, x) = mim * s / (K1 * x + s)
DEF fnt (s) = tetaM * s / (Kp + s + s * s / Ki)


' integracija
PRINT
PRINT "SIMULACIJA FERMENTACIJE"
PRINT "------------------------"
PRINT
Ndim = 5
REM upute za RK-4 algoritam integracije
REM Y() je vektor velicina stanja
REM Ndim je dimenzija vektora Y()
REM F() je vektor jednadzbi modela
REM Model se upisuje u obliku Y()=F( Y(),time )
REM time je nezavisna varijabla
REM Hkorak je korak integracije
REM Tinterval je interval u kojem se ispisuju rezultati
REM Tprint je pocetak ispisa rezultata
REM Tfinal je konacno vrijeme integracije
REM Upisani LABEL brojevi su obavezni
DIM y(Ndim), s(Ndim), p(Ndim), F(Ndim)
time = 0
Tinterval = 5
Tfinal = 150
Hkorak = .5
ik = 1: timef = 10
y(1) = xp: x = y(1)
y(2) = sp: s = y(2)
y(3) = pp: p = y(3)
y(4) = Vo: v = y(4)
y(5) = 0
q = q(1): sf = sf(1): ik = 1
REM obavezna oznaka pocetka integracije
Index = 0
REM naredbe za ispis rezultata
Tprint = Tinterval
60 PRINT "t(h)="; time
PRINT "ulazne velicine"
PRINT "Q(m3/h)="; INT(q / 1000), "sf(g/l)="; sf
PRINT "velicine stanja"
PRINT "x(g/l)="; INT(1000 * x) / 1000, "s(g/l)="; INT(1000 * s) / 1000
PRINT "p(g/l)="; INT(1000 * p) / 1000, "V(m3)="; INT(v / 10) / 100
PRINT : INPUT "nastavak "; r$
REM ...........................................
REM Upisati model
70 REM jednadzbe modela
' pritok
q = q(ik): sf = sf(ik)
IF v >= Vf THEN q = 0
IF time > timef THEN ik = ik + 1
IF time > timef THEN timef = timef + 10
x = y(1): s = y(2): p = y(3): v = y(4)
IF s < 0 THEN s = 0
F(1) = fnm(s, x) * x - q * x / v
F(2) = q * (sf - s) / v - fnt(s) * x / Yp - fnm(s, x) * x / Yx - Mx * x
F(3) = fnt(s) * x - K * p - q * p / v
F(4) = q
F(5) = CT + CS * q * sf
REM ...........................................
REM poziv RK-4
80 GOSUB 9000
IF Lindex = 1 THEN GOTO 70
IF time < Tprint - Hkorak / 2 GOTO 70
Tprint = Tprint + Tinterval
IF time < Tfinal + Hkorak GOTO 60
PRINT "***************************"
PRINT "KRAJ FERMENTACIJE"
J = CP * p * v - y(5)
END


9000 REM  Runge-Kutta 4 algoritam za integraciju
   Index = Index + 1
IF Index = 1 THEN GOTO 9040
IF Index = 2 THEN GOTO 9050
IF Index = 3 THEN GOTO 9060
IF Index = 4 THEN GOTO 9070
IF Index = 5 THEN GOTO 9080
9040 Lindex = 1: RETURN
9050 FOR J = 1 TO Ndim
s(J) = y(J)
p(J) = F(J)
y(J) = s(J) + .5 * Hkorak * F(J)
NEXT J
time = time + .5 * Hkorak
Lindex = 1: RETURN
9060 FOR J = 1 TO Ndim
p(J) = p(J) + 2 * F(J)
y(J) = s(J) + .5 * Hkorak * F(J)
NEXT J
Lindex = 1: RETURN
9070 FOR J = 1 TO Ndim
p(J) = p(J) + 2 * F(J)
y(J) = s(J) + Hkorak * F(J)
NEXT J
time = time + .5 * Hkorak
Lindex = 1: RETURN
9080 FOR J = 1 TO Ndim
y(J) = s(J) + Hkorak / 6 * (p(J) + F(J))
NEXT J
Lindex = 2: Index = 0: RETURN
REM end RK-4

