'Vjezba : Optimiranje proizvodnje penicilina

DECLARE SUB rkf (Nvar, t, h, y(), e())
DECLARE SUB func (t, y(), f())
DECLARE SUB graf (Ndat, tmax, ymin, ymax, t$, y$, TG(), YG(), YR())
DECLARE SUB kvadrat (a, b)
'$INCLUDE: 'c:\vjezbe\crkf.bas'

OPEN "C:\vjezbe\pen_teor.txt" FOR OUTPUT AS #2
OPEN "C:\vjezbe\pen_rez.txt" FOR APPEND AS #1

CLS
PRINT "--------------------------------------------------------------------"
PRINT "VJEZBA: OPTIMIRANJE PROIZVODNJE PENICILINA"
PRINT
PRINT "Podaci za model proizvodnje penicilina preuzeti su iz radova:"
PRINT "R.K. Bajpai, M. Reuss"
PRINT "  Evaluation of Feeding Strategies in Carbon - Regulated Secondary"
PRINT "  Metabolite Production Through Mathematical Modelling "
PRINT "  Biotechnol. Bioeng. 23(4),717-738(1981),"
PRINT "Ka-Yiu San, G. Stephanopoulos "
PRINT "  Optimization of Fed-Batch Penicillin Fermentation: A Case of"
PRINT "  Singular Optimal Control with State Constraints"
PRINT "  Biotechnol. Bioeng. 34(1), 72-78 (1989)."
PRINT "-----------------------------------------------------------------------"
PRINT "U programu se prikazuju trenutne vrijednosti velicina stanja u reaktoru"
PRINT "i referentne (optimalne) vrijednosti za slijedeci interval od 5 h. "
PRINT
PRINT "Potrebno je zadavati vrijednosti upravljackih velicina,"
PRINT "volumnog pritoka Qf(m3/h) i koncentracije glukoze Sf(g/l) u pritoku."
PRINT
PRINT "Maksimalne vrijednosti upravljackih velicina su Qf=10 m3/h i Sf=500 g/l"; ""
PRINT "U datoteku (C:\QBasic\Vjezbe\PEN_REZ.TXT) se zapisuju slijedece"
PRINT "vrijednosti: t, Qf, Sf, x, s, p, V"
PRINT
PRINT "Na kraju simulacije se izracunavaju bilance mase i ostvareni profit ($)."
PRINT "------------------------------------------------------------------------"
INPUT "Ako zelite zapoceti program pritisnite tipku ENTER"; R$

PRINT #2,
PRINT #2, "VJEZBA: OPTIMIRANJE PROIZVODNJE PENICILINA"
PRINT #2,
PRINT #2, "Podaci za model proizvodnje penicilina preuzeti su iz radova:"
PRINT #2, "R.K. Bajpai, M. Reuss"
PRINT #2, "  Evaluation of Feeding Strategies in Carbon - Regulated Secondary"
PRINT #2, "  Metabolite Production Through Mathematical Modelling "
PRINT #2, "  Biotechnol. Bioeng. 23(4),717-738(1981),"
PRINT #2, "Ka-Yiu San, G. Stephanopoulos "
PRINT #2, "  Optimization of Fed-Batch Penicillin Fermentation: A Case of"
PRINT #2, "  Singular Optimal Control with State Constraints"
PRINT #2, "  Biotechnol. Bioeng. 34(1), 72-78 (1989)."
PRINT #2, "-----------------------------------------------------------------------"
PRINT #2, "U programu se prikazuju trenutne vrijednosti velicina stanja u reaktoru"
PRINT #2, "i referentne (optimalne) vrijednosti za slijedeci interval od 5 h. "
PRINT #2,
PRINT #2, "Potrebno je zadavati vrijednosti upravljackih velicina,"
PRINT #2, "volumnog pritoka Qf(m3/h) i koncentracije glukoze Sf(g/l) u pritoku."
PRINT #2,
PRINT #2, "Maksimalne vrijednosti upravljackih velicina su Qf=10 m3/h i Sf=500 g/l"; ""
PRINT #2, "U datoteku (C:\QBasic\Vjezbe\PEN_REZ.TXT) se zapisuju slijedece"
PRINT #2, "vrijednosti: t, Qf, Sf, x, s, p, V"
PRINT #2,
PRINT #2, "Na kraju simulacije se izracunavaju bilance mase i ostvareni profit ($)."
PRINT #2,

PRINT #1, "MM-DD-GGGG", "Vrijeme"
PRINT #1, DATE$, TIME$
PRINT #1, "-------------------------------"
PRINT #1, TAB(1); " t"; TAB(10); "  Qf"; TAB(20); "Sf"; TAB(30); " x"; TAB(40); " s"; TAB(50); " p"; TAB(60); "V"
PRINT #1, TAB(1); " (h)"; TAB(10); "  (m3/h)"; TAB(20); "(g/L)"; TAB(30); " (g/L)"; TAB(40); " (g/L)"; TAB(50); " (g/L)"; TAB(60); "(m3)"

Nvar = 4

Vp = 250000!
Vf = 500000!
xp = 1.5: sp = 1: pp = 0
miM = .11: K1 = .006: thetaM = .004: Kp = .00001
Ki = .1: K2 = .01: Yx = .47: Yp = 1.2: Mx = .029
DIM y(Nvar), f(Nvar), e(Nvar)
DIM XR(31), SR(31), VR(31), PR(31)
DIM XG(31), SG(31), VG(31), PG(31), TG(31)
FOR i = 1 TO 31
READ XR(i), SR(i), PR(i), VR(i)
NEXT i
DATA 1.5,1,250,0
DATA 2.92,9.8,1.08e-3,256
DATA 4.71,13.87,1.55e-3,261
DATA 8.3,14.8,2.32e-3,266
DATA 13.5,10.2,3.69e-3,271
DATA 20.67,0.054,1.98e-2,275
DATA 22.9,3.4e-2,0.33,280
DATA 28.5,0.11,0.52,290
DATA 33.1,8.47e-2,0.78,300
DATA 37.1,7e-2,1.1,310
DATA 40.5,5.97e-2,1.47,320
DATA 40.5,6.26e-3,2.11,325
DATA 43.2,5.01e-2,2.47,335
DATA 44.2,2.19e-2,2.98,342.5
DATA 45,1.96e-2,3.5,350
DATA 45.63,1.76e-2,4,357.6
DATA 46.1,1.59e-2,4.47,365
DATA 46.5,1.43e-2,4.95,372.5
DATA 46.75,1.3e-2,5.4,379.9
DATA 48.1,2.96e-2,5.71,389.9
DATA 49.2,0.026,6,400
DATA 50.1,2.35e-2,6.36,410
DATA 50.7,0.02,6.7,420
DATA 51.2,0.019,7.04,430
DATA 51.6,1.7e-2,7.4,440
DATA 51.8,1.53e-2,7.73,450
DATA 52,1.37e-2,8.1,460
DATA 52.05,1.3e-2,8.4,470
DATA 52.05,1.3e-2,8.72,480
DATA 52.05,1.3e-2,9.04,490
DATA 52.05,1.3e-2,9.4,500

y(1) = Vp * xp      ' pocetna masa biomase
y(2) = Vp * sp      ' pocetna masa glukoze
y(3) = Vp * pp      ' pocetna masa penicilina
y(4) = Vp           ' pocetni volumen komine
h = .1

FOR i = 1 TO Nvar
e(i) = 1000
NEXT i
t = 0: tfinal = 150
Qf = 5: Sf = 50
tPRINT = 0: tPRINTk = 5
index = 2

'rem pocetna stanja
PRINT
masag = 0

10 REM pocetak integracije
V = y(4): x = y(1) / V: s = y(2) / V: p = y(3) / V
IF V >= Vf THEN Qf = 0
IF t >= tPRINT THEN
CLS
IF t = 0 THEN PRINT "pocetne vrijednosti upravljackih velicina Qf(m3/h)="; Qf; "  Sf(g/l)="; Sf
IF t = 0 THEN Qf = 5 AND Sf = 50
               PRINT "t(h)="; USING "###"; INT(t * 100) / 100;
               PRINT "                   VELICINE STANJA U BIOREAKTORU"
               PRINT "-----------------------------------------------------------------------"
               PRINT "x(g/l)="; INT(x * 1000) / 1000;
               PRINT TAB(20); "s(g/l)="; INT(s * 1000) / 1000;
               PRINT TAB(40); "p(g/l)="; INT(p * 1000) / 1000;
               PRINT TAB(60); "V(m3)="; INT(V / 100) / 10

               XG(index - 1) = x: SG(index - 1) = LOG(ABS(s + .000001))
               IF s = 0 THEN SG(index - 1) = -7
               PG(index - 1) = p: VG(index - 1) = V / 1000
               TG(index - 1) = t
               tPRINT = tPRINT + tPRINTk
               PRINT "-----------------------------------------------------------------------"
               IF index = 32 THEN GOTO 999
               PRINT
               PRINT TAB(5); "******************************************************"
               PRINT TAB(5); "------------------------------------------------------"
               PRINT TAB(5); "REFERENTNO STANJE U BIOREAKTORU/ blizu optimalnog"
               PRINT TAB(5); "       ZA SLIJEDECIH 5 h"
               PRINT TAB(5); "------------------------------------------------------"
               PRINT TAB(5); "x(g/l)="; XR(index),
               PRINT TAB(5); "s(g/l)="; SR(index)
               PRINT TAB(5); "p(g/l)="; PR(index),
               PRINT TAB(5); "V(m3)="; VR(index)
               index = index + 1
               PRINT TAB(5); "******************************************************"
               PRINT
               PRINT "--------------------------------------------------"
               PRINT "UPISITE UPRAVLJACKE VELICINE ZA SLIJEDECI INTERVAL"
               PRINT "--------------------------------------------------"

'100 INPUT "Qf(m3/h)="; Qf: IF Qf < 0 THEN Qf = 0
100 Qf = 1.73
               IF Qf > 10 THEN PRINT "max. Qf=10": GOTO 100
               IF V >= Vf THEN PRINT "REAKTOR JE PUN DO VRHA Qf=0": Qf = 0
               Qf = Qf * 1000

'101 INPUT "Sf(g/l)="; Sf: IF Sf < 0 THEN Sf = 0
101 Sf = 499
               IF Sf > 500 THEN PRINT "Sf max =500 (g/l)": GOTO 101
               IF V >= Vf THEN PRINT "NEMA PRITOKA Sf=0": Sf = 0
               masag = masag + Qf * Sf
               PRINT : PRINT
PRINT "**********************************************************"
              
PRINT #1, USING "###"; TAB(1); t;
PRINT #1, USING "###.##"; TAB(10); Qf / 1000; TAB(20); Sf; TAB(30); x; TAB(40); s; TAB(50); p; TAB(60); V / 1000
              
               END IF

'INPUT R$
CALL rkf(Nvar, t, h, y(), e())
IF (t - 1 * h) <= tfinal GOTO 10

999 REM graf

PRINT "KRAJ PROIZVODNJE"
PRINT : PRINT
PRINT "GRAFICKI PRIKAZ TOKA PROIZVODNJE"
INPUT "Za prikaz koncentracije glukoze u reaktoru pritisnite ENTER"; R$

SCREEN 12
Ndat = 31: tmax = t + 5
IF TG(Ndat) = 0 THEN Ndat = 30
smin = -8: smax = 5
FOR i = 1 TO Ndat
SR(i) = LOG(SR(i))
NEXT i
t$ = "VRIJEME (h)"
y$ = "LN KONCENTRACIJE GLUKOZE U REAKTORU (g/l)"
CALL graf(Ndat, tmax, smin, smax, t$, y$, TG(), SG(), SR())


xmin = 0: xmax = 100
y$ = "KONCENTRACIJA BIOMASE U REAKTORU (g/mol) "
CALL graf(Ndat, tmax, xmin, xmax, t$, y$, TG(), XG(), XR())

pmin = 0: pmax = 10
y$ = "KONCENTRACIJA PENICILINA U REAKTORU  (g/l)"
CALL graf(Ndat, tmax, pmin, pmax, t$, y$, TG(), PG(), PR())

vmin = 250: vmax = 600
y$ = "VOLUMEN KOMINE U REAKTORU "
CALL graf(Ndat, tmax, vmin, vmax, t$, y$, TG(), VG(), VR())

CLS
PRINT "             ANALIZA REZULTATA"
PRINT "----------------------------------------------------"
PRINT
PRINT "        POSTIGNUTO U OVOJ PROIZVODNJI"
PRINT "----------------------------------------------------"

PRINT #1,
PRINT #1, "             ANALIZA REZULTATA"
PRINT #1, "----------------------------------------------------"
PRINT #1,
PRINT #1, "        POSTIGNUTO U OVOJ PROIZVODNJI"
PRINT #1, "----------------------------------------------------"

tf = t: Vf = V: V0 = 500000
cp = .025: ct = 168: cs = .0008547
mbiomase = Vf * x
mpenicil = Vf * p
vprod = p * Vf / tf / V0
sprod = p * Vf / V0 / tf / masag
prinosb = x * Vf / masag
prinosg = p * Vf / masag

PRINT "PROIZVEDENO BIOMASE (kg) = "; mbiomase / 1000
PRINT "PROIZVEDENO PENICILINA (kg) = "; mpenicil / 1000
PRINT "UTROSENO GLUKOZE (kg) ="; masag / 1000
PRINT "VOLUMNA PRODUKTIVNOST PENICILINA (kg penicilina/m3/h)="; p * Vf / tf / V0
PRINT "SPECIFICNA PRODUKTIVNOST GLUKOZE (g penicilina/kg glukoze/h)="; p * Vf / masag / tf * 1000
PRINT "PRINOS BIOMASA/GLUKOZA Yx/s (kg/kg) ="; x * Vf / masag
PRINT "PRINOS PENICILIN/GLUKOZA Yp/s (kg/kg) ="; p * Vf / masag
PRINT "----------------------------------------------------"
PRINT

PRINT #1, "PROIZVEDENO BIOMASE (kg) = "; mbiomase / 1000
PRINT #1, "PROIZVEDENO PENICILINA (kg) = "; mpenicil / 1000
PRINT #1, "UTROSENO GLUKOZE (kg) ="; masag / 1000
PRINT #1, "VOLUMNA PRODUKTIVNOST PENICILINA (kg penicilina/m3/h)="; p * Vf / tf / V0
PRINT #1, "SPECIFICNA PRODUKTIVNOST GLUKOZE (g penicilina/kg glukoze/h)="; p * Vf / masag / tf * 1000
PRINT #1, "PRINOS BIOMASA/GLUKOZA Yx/s (kg/kg) ="; x * Vf / masag
PRINT #1, "PRINOS PENICILIN/GLUKOZA Yp/s (kg/kg) ="; p * Vf / masag
PRINT #1, "----------------------------------------------------"
PRINT #1,


PRINT "OPTIMALNE VRIJEDNOSTI NA OSNOVU REFERENTNOG PROGRAMA"
PRINT "----------------------------------------------------"

PRINT "PROIZVEDENO BIOMASE (kg) = "; 25786.43
PRINT "PROIZVEDENO PENICILINA (kg) = "; 4749.434
PRINT "UTROSENO GLUKOZE (kg) ="; 25000
PRINT "VOLUMNA PRODUKTIVNOST PENICILINA (kg penicilina/m3/h)="; .06331
PRINT "SPECIFICNA PRODUKTIVNOST GLUKOZE (g penicilina/kg glukoze/h)="; 1.266264
PRINT "PRINOS BIOMASA/GLUKOZA Yx/s (kg/kg) ="; 1.031457
PRINT "PRINOS PENICILIN/GLUKOZA Yp/s (kg/kg) ="; .18997
PRINT "----------------------------------------------------"

PRINT #1, "OPTIMALNE VRIJEDNOSTI NA OSNOVU REFERENTNOG PROGRAMA"
PRINT #1, "----------------------------------------------------"
PRINT #1, "PROIZVEDENO BIOMASE (kg) = "; 25786.43
PRINT #1, "PROIZVEDENO PENICILINA (kg) = "; 4749.434
PRINT #1, "UTROSENO GLUKOZE (kg) ="; 25000
PRINT #1, "VOLUMNA PRODUKTIVNOST PENICILINA (kg penicilina/m3/h)="; .06331
PRINT #1, "SPECIFICNA PRODUKTIVNOST GLUKOZE (g penicilina/kg glukoze/h)="; 1.266264
PRINT #1, "PRINOS BIOMASA/GLUKOZA Yx/s (kg/kg) ="; 1.031457
PRINT #1, "PRINOS PENICILIN/GLUKOZA Yp/s (kg/kg) ="; .18997
PRINT #1,


INPUT "Za nastavak pritisnite ENTER"; R$
CLS
PRINT "           EKONOMIJA  PROIZVODNJE"
PRINT "----------------------------------------------------"
PRINT
PRINT "        POSTIGNUTO U OVOJ PROIZVODNJI"
PRINT "----------------------------------------------------"
PRINT "VRIJEDNOST PROIZVODA (PENICILINA ) ="; cp * p * Vf
PRINT "TROSKOVI POGONA ="; ct * tf
PRINT "TROSAK ZA CIJENU GLUKOZE ="; cs * masag
PRINT "PROFIT ($) ="; cp * p * Vf - ct * tf - cs * masag
PRINT "----------------------------------------------------"
PRINT
PRINT "OPTIMALNE VRIJEDNOSTI NA OSNOVU REFERENTNOG PROGRAMA"
PRINT "----------------------------------------------------"
PRINT "VRIJEDNOST PROIZVODA (PENICILINA ) ="; 118735.8
PRINT "TROSKOVI POGONA ="; 25205
PRINT "TROSAK ZA CIJENU GLUKOZE ="; 21367.5
PRINT "PROFIT ($) ="; 72163.34
PRINT "----------------------------------------------------"
PRINT
PRINT "Uspjesnost provedene simulacije (%): "; (cp * p * Vf - ct * tf - cs * masag) / 72163.34 * 100
PRINT "===================================================="

PRINT #1, "           EKONOMIJA PROIZVODNJE"
PRINT #1, "----------------------------------------------"
PRINT #1,
PRINT #1, "        POSTIGNUTO U OVOJ PROIZVODNJI"
PRINT #1, "----------------------------------------------"
PRINT #1, "VRIJEDNOST PROIZVODA (PENICILINA ) ="; cp * p * Vf
PRINT #1, "TROSKOVI POGONA ="; ct * tf
PRINT #1, "TROSAK ZA CIJENU GLUKOZE ="; cs * masag
PRINT #1, "PROFIT ($) ="; cp * p * Vf - ct * tf - cs * masag
PRINT #1,
PRINT #1, "OPTIMALNE VRIJEDNOSTI NA OSNOVU REFERENTNOG PROGRAMA"
PRINT #1, "----------------------------------------------------"
PRINT #1, "VRIJEDNOST PROIZVODA (PENICILINA) ="; 118735.8
PRINT #1, "TROSKOVI POGONA ="; 25205
PRINT #1, "TROSAK ZA CIJENU GLUKOZE ="; 21367.5
PRINT #1, "PROFIT ($) ="; 72163.34
PRINT #1, "----------------------------------------------------"
PRINT #1, "Uspjesnost provedene simulacije (%): "; (cp * p * Vf - ct * tf - cs * masag) / 72163.34 * 100
PRINT #1, "===================================================="
PRINT #1,

CLOSE #1
CLOSE #2
END

SUB func (t, y(), f())
SHARED miM, K1, thetaM, Kp, Ki, K2, Yx, Yp, Mx, Vf
SHARED Qf, Sf
V = y(4): x = y(1) / V: s = y(2) / V: p = y(3) / V
IF s < 0 THEN s = 0
mi = miM * s / (K1 * x + s)
theta = thetaM * s / (Kp + s + s * s / Ki)
f(1) = V * mi * x
f(2) = Qf * Sf - 1 / Yp * V * theta * x - 1 / Yx * V * mi * x - Mx * V * x
f(3) = V * theta * x - V * K2 * p
f(4) = Qf
END SUB

SUB graf (N, tmax, ymin, ymax, t$, y$, t(), y(), YR())
DIM tt(N), yy(N)
REM  graf
CLS
LOCATE 1, 6: PRINT y$
PSET (50, 20)
DRAW "D250": DRAW "R570": DRAW "U250": DRAW "L570"
LOCATE 21, 5: PRINT INT(tmin): LOCATE 21, 75: PRINT INT(tmax)
LOCATE 22, 35: PRINT t$
LOCATE 2, 1: PRINT INT(ymax)
LOCATE 20, 1: PRINT INT(ymin)

REM podaci
FOR i = 1 TO N
tt(i) = t(i) / tmax * 570 + 50
yy(i) = (-(y(i) - ymin) / (ymax - ymin) + 1) * 250 + 20
NEXT i

PSET (tt(1), yy(1))
FOR i = 2 TO N
LINE (tt(i - 1), yy(i - 1))-(tt(i), yy(i))
aa = tt(i)
bb = (-(YR(i) - ymin) / (ymax - ymin) + 1) * 250 + 20
CALL kvadrat(aa, bb)
NEXT

LOCATE 23, 1: PRINT "LINIJA /POSTIGNUTA STANJA     KVADRATI/REFERENTNA STANJA"
LOCATE 24, 1: INPUT "Za nastavak pritisnite ENTER "; R$

END SUB

SUB kvadrat (a, b)
PSET (a - 3, b - 3)
LINE (a - 3, b - 3)-(a - 3, b + 3)
LINE (a - 3, b + 3)-(a + 3, b + 3)
LINE (a + 3, b + 3)-(a + 3, b - 3)
LINE (a + 3, b - 3)-(a - 3, b - 3)
END SUB

SUB rkf (N, t, h, y(), e())
DIM ys(N), f(N), er(N)
DIM s1(N), s2(N), s3(N), s4(N), s5(N), s6(N)
SHARED C()
ts = t
FOR i = 1 TO N
ys(i) = y(i)
NEXT i
1 IF h < .0001 THEN PRINT "integracija prespora, uzmite nove Qf i Sf h<<": END
CALL func(t, y(), f())
  FOR i = 1 TO N
  s1(i) = h * f(i)
  NEXT i
t = ts + C(1) * h
FOR i = 1 TO N
y(i) = ys(i) + C(1) * s1(i)
NEXT i
CALL func(t, y(), f())
  FOR i = 1 TO N
  s2(i) = h * f(i)
  NEXT i
t = ts + C(2) * h
FOR i = 1 TO N
y(i) = ys(i) + C(3) * s1(i) + C(4) * s2(i)
NEXT i
CALL func(t, y(), f())
  FOR i = 1 TO N
  s3(i) = h * f(i)
  NEXT i
t = ts + C(5) * h
FOR i = 1 TO N
y(i) = ys(i) + C(6) * s1(i) - C(7) * s2(i) + C(8) * s3(i)
NEXT i
CALL func(t, y(), f())
  FOR i = 1 TO N
  s4(i) = h * f(i)
  NEXT i
t = ts + h
FOR i = 1 TO N
y(i) = ys(i) + C(9) * s1(i) - 8 * s2(i) + C(10) * s3(i) - C(11) * s4(i)
NEXT i
CALL func(t, y(), f())
  FOR i = 1 TO N
  s5(i) = h * f(i)
  NEXT i
t = ts + h / 2
FOR i = 1 TO N
y(i) = ys(i) - C(12) * s1(i) + 2 * s2(i) - C(13) * s3(i) + C(14) * s4(i) - C(15) * s5(i)
NEXT i
CALL func(t, y(), f())
  FOR i = 1 TO N
  s6(i) = h * f(i)
  NEXT i
FOR i = 1 TO N
er(i) = (C(16) - C(20)) * s1(i) + (C(17) - C(21)) * s3(i)
er(i) = er(i) + (C(18) - C(22)) * s4(i) + (C(23) - C(19)) * s5(i) - C(24) * s6(i)
NEXT i
qmax = 0
FOR i = 1 TO N
Q = ABS(er(i) / e(i))
IF Q > qmax THEN qmax = Q
NEXT i
IF qmax < 1 THEN
            t = ts + h
            FOR i = 1 TO N
 y(i) = ys(i) + C(16) * s1(i) + C(17) * s3(i) + C(18) * s4(i) - C(19) * s5(i)
            NEXT i
            Q = 4 * qmax
            Q = (1 / Q) ^ .25
            IF Q > 3 THEN h = 3 * h
            IF Q <= 3 THEN h = Q * h
            IF Q = 0 THEN h = 3 * h
ELSE
t = ts
FOR i = 1 TO N
y(i) = ys(i)
NEXT i
h = h / 2
GOTO 1
END IF
IF h > 5 THEN h = 1     ' za pritok
FOR i = 1 TO N
IF y(i) < 0 THEN y(i) = 0
NEXT i
END SUB

