REM Promijenite naziv ove datoteke u "SMRZAVA_.BAS"
REM (Spremite datoteku s novim nazivom u folder "...\VJEZBE\")

REM O PROGRAMU:
REM -----------------------------------------------------------------
REM RACUNALNI PROGRAM ZA SIMULACIJU PROCESA SMRZAVANJA PROIZVODA
REM Program zapisuje izlazne podatke u datoteke na adresi:
REM C:\MODELI\SMRZAV_1.TXT i C:\MODELI\SMRZAVA2.TXT
REM U datoteci "SMRZAVA_1" su svi izracunati podaci
REM U datoteci "SMRZAVA_2" su podaci za graficki prikaz

REM Upute za rad:
REM "------------"
REM Upisite vrijednosti ulaznih varijabli i pokrenite program
REM "(ako zelite ispraviti unesene vrijednosti pritisnite kombinaciju"
REM " tipki: <Ctrl-Break> ili <Ctrl-ScrLk>)"

REM Promijenite odabranu ulaznu vrijednost i ponovite simulaciju
REM Za svaku novu ulaznu vrijednost ponovo pokrenite simulaciju

REM Izracunati podaci spremljeni su u datoteke "SRMZAVA_x.TXT"

CLS
PRINT "O PROGRAMU"
PRINT "-----------------------------------------------------------------"
PRINT "RACUNALNI PROGRAM ZA SIMULACIJU PROCESA SMRZAVANJA PROIZVODA"
PRINT "Program zapisuje izlazne podatke u datoteke na adresi:"
PRINT "C:\MODELI\SMRZAV_1.TXT i C:\MODELI\SMRZAV_2.TXT"
PRINT U; datoteci; "SMRZAV_1"; su; svi; izracunati; podaci
PRINT U; datoteci; "SMRZAV_2"; su; podaci; za; graficki; prikaz
PRINT
PRINT "UPUTE ZA RAD:"
PRINT "-------------"
PRINT "Upisite vrijednosti ulaznih varijabli i pokrenite program"
PRINT "(ako zelite ispraviti unesene vrijednosti pritisnite kombinaciju"
PRINT " tipki: <Ctrl-Break> ili <Ctrl-ScrLk>)"
PRINT
PRINT "Promijenite odabranu ulaznu vrijednost i ponovite simulaciju"
PRINT "Za svaku novu ulaznu vrijednost ponovo pokrenite simulaciju"
PRINT
PRINT "Izracunati podaci spremljeni su u datoteke "; SRMZAVACLS
10 REM SLIJEDITE UPUTE I UPISITE TRAZENE VRIJEDNOSTI:

PRINT "DINAMIKA SMRZAVANJA PREHRAMBENIH PROIZVODA"
PRINT "----------------------------------------------------------"

REM "Upisite naziv prehrambenog proizvoda:"
naziv$ = "Teletina"

REM "Upisite dimenzije proizvoda pakiranog u obliku kvadra:"

REM "Visina kvadra (maksimalna vrijednost=0.5 m) D(m)="
visina = .5

REM "Kolika je sirina kvadra (neka je maksimalno 0.1*D) L(m)="
sirina = .05

REM "Upisite naziv ambalaznog materijala"
ambalaza$ = "papir"

REM "Upisite debljinu ambalaze d(m)="
damb = .0002

REM "Pocetna temperatura materijala (10<=T<=30 C)"
Tpoc = 20

PRINT "Upisite temperaturu zraka za hladjenje  od 0 C do -50 C:"
t0 = -20

REM "Upisite temperaturu na kojoj proizvod smrzava Ts (C)"
REM "Ako Vam nije poznata vrijednost iz literature, upisite proizvoljnu "
REM "vrijednost, npr. -5 C"
Ts = -2

REM "Upisite brzinu rashladnog zraka v (m/s)="
brzina = 10

REM "Upisite vrijednost koeficijenta toplinske vodljivosti"
REM "prehrambenog proizvoda u nesmrznutom stanju (W/mK)"
kproizvodat = 1

REM "Upisite vrijednost specificne topline nesmrznutog proizvoda (J/kg)"
cpp = 2948

REM "Upisite gustocu nesmrznutog proizvoda"
REM "(ako ne raspolazete s podatkom upisite vrijednost 1000 kg/m3)"
gustocap = 1200

REM "Upisite maseni udio vode (x) u proizvodu  (0< x <1)"
x = .63

REM "Upisite koeficijent toplinske vodljivosti ambalaze (W/mK)"
kambalaze = .14

cpsuhet = cpp - x * 4180: IF cpsuhet < 0 THEN cpsuhet = 0
cpps = cpsuhet + x * 4180 * .48
rosmrz = gustocap * (1 - x * .1)

CLS
PRINT "NAMIRNICA ODABRANA ZA SMRZAVANJE:"; naziv$
PRINT "----------------------------------------------------------"
PRINT "DIMENZIJE PAKETA KOJI IMA OBLIK KVADRA"
PRINT " Visina (m) ="; visina
PRINT " Sirina (m) ="; sirina
PRINT "PODACI ZA AMBALAZU "; ambalaza$
PRINT "Debljina ambalaze (m)="; damb
PRINT "Koeficijent toplinske vodljivosti ambalaze k (W/mK) ="; kambalaze
PRINT "Proizvod se smrzava zrakom temperature To (C) ="; t0
PRINT "Brzina zraka za hladjenje v (m/s)="; brzina
PRINT "Temperatura na kojoj proizvod smrzava Ts (C)="; Ts
PRINT "Koeficijent toplinske vodljivosti proizvoda"
PRINT "u nesmrznutom stanju k (W/mK) ="; kproizvodat
PRINT "Gustoca proizvoda u nesmrznutom stanju ro (kg/m3) ="; gustocap
PRINT "Gustoca smrznutog proizvoda ro (kg/m3)="; rosmrz
PRINT "Specificna toplina nesmrznutog proizvoda Cp (J/kg) ="; cpp
PRINT "Specificna toplina smrznutog proizvoda Cp (J/kg) ="; cpps
PRINT "Maseni udio vode u proizvodu je x ="; x
PRINT "----------------------------------------------------------"
INPUT "Za nastavak pritisnite tipku 'Enter'", r$

REM MKDIR "c:\modeli"
OPEN "c:\smrzav_1.txt" FOR APPEND AS #1
OPEN "c:\smrzav_2.txt" FOR APPEND AS #2

PRINT #1, U; datoteci; "SMRZAV_1.TXT"; su; svi; izracunati; podaci
PRINT #1,
PRINT #1, "NAMIRNICA ODABRANA ZA SMRZAVANJE:"; naziv$
PRINT #1, "----------------------------------------------------------"
PRINT #1, "DIMENZIJE PAKETA KOJI IMA OBLIK KVADRA"
PRINT #1, " Visina (m) ="; visina
PRINT #1, " Sirina (m) ="; sirina
PRINT #1, " Temperatura proizvoda Tpoc (C) ="; Tpoc
PRINT #1, "PODACI ZA AMBALAZU "; ambalaza$
PRINT #1, " Debljina ambalaze (m)="; damb
PRINT #1, " Koeficijent toplinske vodljivosti ambalaze k (W/mK) ="; kambalaze
PRINT #1, " Proizvod se smrzava zrakom temperature To (C) ="; t0
PRINT #1, " Brzina zraka za hladjenje v (m/s)="; brzina
PRINT #1, " Temperatura na kojoj proizvod smrzava Ts (C)="; Ts
PRINT #1, " Koeficijent toplinske vodljivosti proizvoda"
PRINT #1, "  u nesmrznutom stanju k (W/mK) ="; kproizvodat
PRINT #1, " Gustoca proizvoda u nesmrznutom stanju ro (kg/m3) ="; gustocap
PRINT #1, " Gustoca smrznutog proizvoda ro (kg/m3)="; rosmrz
PRINT #1, " Specificna toplina nesmrznutog proizvoda Cp (J/kg) ="; cpp
PRINT #1, " Specificna toplina smrznutog proizvoda Cp (J/kg) ="; cpps
PRINT #1, " Maseni udio vode u proizvodu je x ="; x
PRINT #1, "----------------------------------------------------------"
PRINT #1,

PRINT #2, U; datoteci; "SMRZAV_2.TXT"; su; podaci; za; graficki; prikaz
PRINT #2,
PRINT #2, "NAMIRNICA ODABRANA ZA SMRZAVANJE:"; naziv$
PRINT #2, "----------------------------------------------------------"
PRINT #2, "DIMENZIJE PAKETA KOJI IMA OBLIK KVADRA"
PRINT #2, " Visina (m) ="; visina
PRINT #2, " Sirina (m) ="; sirina
PRINT #2, " Temperatura proizvoda Tpoc (C) ="; Tpoc
PRINT #2, "PODACI ZA AMBALAZU "; ambalaza$
PRINT #2, " Debljina ambalaze (m)="; damb
PRINT #2, " Koeficijent toplinske vodljivosti ambalaze k (W/mK) ="; kambalaze
PRINT #2, " Proizvod se smrzava zrakom temperature To (C) ="; t0
PRINT #2, " Brzina zraka za hladjenje v (m/s)="; brzina
PRINT #2, " Temperatura na kojoj proizvod smrzava Ts (C)="; Ts
PRINT #2, " Koeficijent toplinske vodljivosti proizvoda"
PRINT #2, "  u nesmrznutom stanju k (W/mK) ="; kproizvodat
PRINT #2, " Gustoca proizvoda u nesmrznutom stanju ro (kg/m3) ="; gustocap
PRINT #2, " Gustoca smrznutog proizvoda ro (kg/m3)="; rosmrz
PRINT #2, " Specificna toplina nesmrznutog proizvoda Cp (J/kg) ="; cpp
PRINT #2, " Specificna toplina smrznutog proizvoda Cp (J/kg) ="; cpps
PRINT #2, " Maseni udio vode u proizvodu je x ="; x
PRINT #2, "----------------------------------------------------------"
PRINT #2,
CLS
PRINT "Odredjivanje koeficijenta prijenosa topline u hidrodinamickom"
PRINT "granicnom sloju"

PRINT #1, "Odredjivanje koeficijenta prijenosa topline u hidrodinamickom"
PRINT #1, "granicnom sloju"

' proracun Reynoldsovog broja
mizraka = (17.19 + .0518 * t0) * .000001
kzraka = .02373 + .0000642# * T
cp = 1004.8
tlak = 101325!
r = 8.314
m = .029
rozraka = tlak * m / r / (273 + t0)
PRINT "Gustoca rashladnog zraka na temperaturi To (C) "; t0
PRINT "            ro (kg/m3) ="; rozraka

PRINT #1, "Gustoca rashladnog zraka na temperaturi To (C) "; t0
PRINT #1, "            ro (kg/m3) ="; rozraka

PRINT "Viskozitet zraka  mi (Pas) ="; mizraka
PRINT "Koeficijent toplinske vodljivosti zraka k (W/mK) ="; kzraka
PRINT "Specificna toplina zraka Cp (J/kgK) ="; cp

PRINT #1, "Viskozitet zraka  mi (Pas) ="; mizraka
PRINT #1, "Koeficijent toplinske vodljivosti zraka k (W/mK) ="; kzraka
PRINT #1, "Specificna toplina zraka Cp (J/kgK) ="; cp

Re = rozraka * brzina * visina / mizraka
PRINT "Reynoldsov broj Re ="; Re;
IF Re < 3500 THEN PRINT "  laminarno strujanje"
IF Re > 3500 THEN PRINT "  turbulentno strujanje"

PRINT #1, "Reynoldsov broj Re ="; Re;
IF Re < 3500 THEN PRINT #1, "  laminarno strujanje"
IF Re > 3500 THEN PRINT #1, "  turbulentno strujanje"

Pr = mizraka * cp / kzraka
PRINT "Prandtlov broj Pr ="; Pr
PRINT #1, "Prandtlov broj Pr ="; Pr

IF Re < 3500 THEN Nu = .664 * Re ^ .5 * Pr ^ (1 / 3)
IF Re > 3500 THEN Nu = .027 * Re ^ .8 * Pr ^ .33
PRINT "Nusseltov broj Nu ="; Nu
PRINT #1, "Nusseltov broj Nu ="; Nu

hg = Nu * kzraka / visina
PRINT "Koeficijent prijenosa topline u granicnom sloju  hg (W/m2K) ="; hg
PRINT "----------------------------------------------------------"
PRINT #1, "Koeficijent prijenosa topline u granicnom sloju  hg (W/m2K) ="; hg
PRINT #1, "----------------------------------------------------------"

INPUT "Za nastavak pritisnite tipku 'Enter'", r$

CLS
PRINT "USPOREDBA OTPORA PRIJENOSU TOPLINE U (m2K/W)"
PRINT #1, "USPOREDBA OTPORA PRIJENOSU TOPLINE U (m2K/W)"

hstar = 3000
r1 = 1 / hg
r2 = damb / kambalaze
r3 = 1 / hstar
r4 = .1 / 2.442
PRINT "Otpor u grani~om sloju zraka "; r1
PRINT "Otpor ambala`e ="; r2
PRINT "Otpor na granici smrznuto/nesmrznuto ="; r3
PRINT "Otpor leda debljine 0.1 (m) na -20 C ="; r4
PRINT "Otpor smrznutog dijela proizvoda raste proporcionalno debljini"
PRINT "zamrznutog proizvoda"
PRINT
PRINT #1, "Otpor u grani~om sloju zraka "; r1
PRINT #1, "Otpor ambala`e ="; r2
PRINT #1, "Otpor na granici smrznuto/nesmrznuto ="; r3
PRINT #1, "Otpor leda debljine 0.1 (m) na -20 C ="; r4
PRINT #1, "Otpor smrznutog dijela proizvoda raste proporcionalno debljini"
PRINT #1, "zamrznutog proizvoda"
PRINT #1,

INPUT "Za nastavak pritisnite tipku 'Enter'", r$

CLS
PRINT "Koeficijent toplinske vodljivosti i gustoca proizvoda"
PRINT "na temperaturi smrzavanja Ts (C)="; Ts
PRINT #1, "Koeficijent toplinske vodljivosti i gustoca proizvoda"
PRINT #1, "na temperaturi smrzavanja Ts (C)="; Ts

kleda = 2.21 - .0114 * Ts
kvode = .588
kpsmrz = kproizvodt + (kleda - kvode) * x
ropsmrz = gustocap - 100 * x
Hl = 335000!
PRINT " ks (W/mK)="; kpsmrz
PRINT " ro (kg/m3)="; ropsmrz
PRINT
PRINT #1, " ks (W/mK)="; kpsmrz
PRINT #1, " ro (kg/m3)="; ropsmrz
PRINT #1,

INPUT "Za nastavak pritisnite tipku 'Enter'", r$

CLS
REM dinamika hladjenja
DIM tos(65), yos(65)
PRINT "DINAMIKA HLADJENJA DO TEMPERATURE SMRZAVANJA"
PRINT #1, "DINAMIKA_HLADJENJA_DO_TEMPERATURE_SMRZAVANJA"
PRINT #2, "DINAMIKA_HLADJENJA_DO_TEMPERATURE_SMRZAVANJA"

tautekuce = gustocap * cpp * sirina / 2 / hg
tausmrz = rosmrz * cpps * sirina / 2 / hg
thladt = tautekuce * LOG((Tpoc - t0) / (Ts - t0))
thlads = tausmrz * LOG((Ts - t0) / 5)
time = 0
delt = thladt / 20

PRINT "vrijeme(min)", " T( C )"
PRINT #1, "Vrijeme_(min)", " T_(C)"
PRINT #2, "Vrijeme_(min)", " T_(C)"

FOR i = 1 TO 21
tmp = t0 + (Tpoc - t0) * EXP(-time / tautekuce)
tos(i) = time: yos(i) = tmp
PRINT time / 60, tmp
PRINT #1, time / 60, tmp
PRINT #2, time / 60, tmp

time = time + delt
NEXT i

thladf = time - delt
ifin = 21

PRINT #1,
'PRINT #2,

INPUT "Za nastavak pritisnite tipku 'Enter'", r$

CLS
PRINT "DINAMIKA SMRZAVANJA VODE U MATERIJALU"
'PRINT #1, "DINAMIKA_SMRZAVANJA_VODE_U_MATERIJALU"
'PRINT #2, "DINAMIKA_SMRZAVANJA_VODE_U_MATERIJALU"

alfa = (Ts - t0) / ropsmrz / x / Hl
beta = r1 + r2 + r3

PRINT , "Vrijeme (min)", "Debljina smrznutog sloja (mm)"
'PRINT #1, , "Vrijeme_(min)", "Debljina_smrznutog_sloja_(mm)"
'PRINT #2, "Vrijeme_(min)", "Debljina_smrznutog_sloja_(mm)"

FOR i = 1 TO 21
del = (i - 1) * sirina / 20 / 2
time = thladf + (beta * del + .5 / kpsmrz * del * del) / alfa
tos(ifin + i) = time: yos(ifin + i) = Ts

PRINT , time / 60, del * 1000
'PRINT #1, time / 60, del * 1000
'PRINT #2, time / 60, del * 1000
NEXT i
'PRINT #1, "--------------------------------------------"
'PRINT #2, "--------------------------------------------"

INPUT "Za nastavak pritisnite tipku 'Enter'", r$

CLS
PRINT "DINAMIKA HLADJENJA SMRZNUTOG PROIZVODA"
PRINT #1, , "DINAMIKA_HLADJENJA_SMRZNUTOG_PROIZVODA "
'PRINT #2, "DINAMIKA_HLADJENJA_SMRZNUTOG_PROIZVODA "

if2 = ifin + 21
del = thlads / 20

PRINT "Vrijeme (min)", "T_(C)"
PRINT #1, , "Vrijeme_(min)", "T_(C)"
'PRINT #2, "Vrijeme_(min)", "T_(C)"

FOR i = 1 TO 21
j = if2 + i
time = time + del
tmp = t0 + (Ts - t0) * EXP(-i * del / tausmrz)
tos(j) = time: yos(j) = tmp
PRINT time / 60, tmp
PRINT #1, time / 60, tmp
PRINT #2, time / 60, tmp
NEXT i

INPUT "Za nastavak pritisnite tipku 'Enter'", r$

tmax = time / 60
PRINT "tmax="; tmax

PRINT #1,
PRINT #2,
PRINT #1, "tmax="; tmax
PRINT #2, "tmax="; tmax

PRINT #1, "#######################################"
PRINT #1,
PRINT #1,

PRINT #2, "#######################################"
PRINT #2,
PRINT #2,

CLOSE #1
CLOSE #2

'U nastavku program iscrtava temperaturu namirnice
'tijekom procesa smrzavanja

FOR i = 1 TO 63
tos(i) = tos(i) / 60 / tmax * 650
yos(i) = (yos(i) - 30) / (-80) * 250
NEXT i

REM  graf
SCREEN 12
CLS
PSET (50, 0)
DRAW "D250": DRAW "R650": DRAW "U250": DRAW "L650"
LOCATE 2, 1: PRINT "T"
LOCATE 3, 1: PRINT "E"
LOCATE 4, 1: PRINT "M"
LOCATE 5, 1: PRINT "P"
LOCATE 6, 1: PRINT "E"
LOCATE 7, 1: PRINT "R"
LOCATE 8, 1: PRINT "A"
LOCATE 9, 1: PRINT "T"
LOCATE 10, 1: PRINT "U"
LOCATE 11, 1: PRINT "R"
LOCATE 12, 1: PRINT "A"
LOCATE 14, 1: PRINT "(C)"
LOCATE 19, 6: PRINT "0": LOCATE 19, 73: PRINT INT(tmax)
LOCATE 20, 30: PRINT "VRIJEME (min) "
LOCATE 21, 10: PRINT "DINAMIKA SMRZAVANJA "; naziv$
PSET (45, 94): DRAW "R655"
LOCATE 1, 2: PRINT "+30"
LOCATE 7, 4: PRINT "0"
LOCATE 18, 2: PRINT "-50"

REM " podaci
PSET (50, yos(1))
FOR i = 2 TO 63
LINE (50 + tos(i - 1), yos(i - 1))-(50 + tos(i), yos(i))
NEXT

END

